/******************************************************************************/
/******************************************************************************/
/*                                                                            */
/* Trigger: DTULTATU_METAVENDA                                                */
/* Tabela : METAVENDA                                                         */
/*                                                                            */
/* Criao:                                                                   */
/* 05/05/2004 - David Moreno Ferreira                                         */
/*                                                                            */
/******************************************************************************/

IF EXISTS(SELECT * FROM sysobjects O, sysusers U
          WHERE
            o.name = 'DTULTATU_METAVENDA' and
            type = 'TR'               and
            u.uid = o.uid             and
            u.name = USER)
   DROP TRIGGER DTULTATU_METAVENDA
GO

CREATE TRIGGER DTULTATU_METAVENDA
ON METAVENDA
FOR INSERT, UPDATE, DELETE
AS
BEGIN
   IF (0 = (SELECT COUNT(*) FROM INSERTED)) BEGIN
      INSERT INTO DELETECACHE (NMTABLECACHE, CDFILICACHE, DSKEYCACHE, DTULTATUCACH)
			      (SELECT 'METAVENDA', null, 'CDMETAVENDA='+ CDMETAVENDA + ';', GETDATE() FROM DELETED)
   END
   ELSE BEGIN
      UPDATE METAVENDA
      SET DTULTATUMEVE = GETDATE()
      FROM INSERTED
      WHERE (ISNULL(METAVENDA.CDMETAVENDA,0) = ISNULL(INSERTED.CDMETAVENDA,0)) AND
            (ISNULL(METAVENDA.NMMETAVENDA,0) = ISNULL(INSERTED.NMMETAVENDA,0));
   END;
END;
GO

